// ------------------------------------
// Version 1.0 : Algorithmes de graphes
// ------------------------------------

// Copyright (C) 2003 (Lacomme, Prins, Sevaux)

// Ce programme (ainsi que la bibliothque objets livre avec le livre)
// est libre, vous pouvez le redistribuer et/ou
// le modifier selon les termes de la
// Licence Publique Gnrale GNU publie par la
// Free Software Foundation (version 2 ou bien toute autre version
// ultrieure choisie par vous).
// Ce programme est distribu car potentiellement utile,
// mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
// y compris les garanties de commercialisation ou
// d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
// Vous devez avoir reu une copie de la Licence
// Publique Gnrale GNU en mme temps que
// ce programme ; si ce n'est pas le cas, crivez  la
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
// 02111-1307, tats-Unis.

// Diffrents sites donnent des copies officielles ou non de cette licence :
// http://www.linux-france.org/article/these/gpl.html
// http://www.gnu.org/copyleft/gpl.html


unit Unit5;

interface

uses
  SysUtils, Types, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm5 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form5: TForm5;

implementation

uses U_TYPE_GRAPHES, U_BASE_GRAPHES, U_GRAPHES,Unit1;

{$R *.dfm}

procedure TForm5.Button1Click(Sender: TObject);
Var G    : T_GRAPHE_LISTE;     {Graphe-liste G}
    W    : PTArcCost; {Ses couts}
    Walk : TSucc;     {Parcours eulerien}
    Last : ArcNum;    {Nombre de noeuds du parcours}
    K    : Cost;      {Son cout}
    Nom  : String;    {Nom du fichier}
    x    : Node;
    ll : String;

Begin

   G:=T_GRAPHE_LISTE.Create;
   Form1.Memo1.Lines.Add    ('Postier chinois oriente');
   Form1.Memo1.Lines.Add('');
   Nom:=Form5.Edit1.Text;

   New (W);
   G.ReadGraph  (Nom,W,Nil,Nil);
   G.AffGraph (Form1.Memo1,W,Nil,Nil,Nil,'Graphe a traiter',78,99);
   G.Postman    (W^,Walk,Last,K);
   G.AffGraph (Form1.Memo1,W,Nil,Nil,Nil,'Graphe apres calcul',78,99);
   Form1.Memo1.Lines.Add ('Parcours trouve, '+IntToStr(Last)+' sommets, cout '+IntToStr(K)+':');
   ll:='';
   For x := 1 to Last do
      ll:=ll+IntToStr(Walk[x])+' ';
   Form1.Memo1.Lines.Add(ll);
   G.Pause ('Click pour continuer...');
   G.Destroy;
   Dispose(W);
   Form5.Close;
end;

end.
